// Copyright 2024 Universidad Politecnica de Madrid (UPM)
// Authors: Santiago Tapia-Fernández
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// --------------------------------------------------------------
//     ATTENTION:    DO NOT EDIT!!
// --------------------------------------------------------------
// This file has been automatically generated by Archetypes.
// Any manual changes will be overwritten the next time the file
// is regenerated.
//
// Archetype was `arty_basic_node' version 1.0.0
// Generation datetime: 2025-03-04 21:10:13.803072
// --------------------------------------------------------------

#include "std_srvs/srv/set_bool.hpp"

#include <chrono>
using namespace std::chrono_literals; // For timer periods

#include "arty_example_alternate_positive/trigger_gen.hpp"
#include "rclcpp/rclcpp.hpp"

namespace arty_example_alternate_positive
{
class node : public rclcpp::Node
{
public:
  node(const rclcpp::NodeOptions & options) : Node("arty_example_alternate_positive", options)
  {

    tick_timer = this->create_wall_timer(500ms, std::bind(&node::tick_callback, this));



    only_positive_client = this->create_client<std_srvs::srv::SetBool>("only_positive");
    while (!only_positive_client->wait_for_service(std::chrono::seconds(1))) {
      if (!rclcpp::ok()) {
        RCLCPP_ERROR(this->get_logger(), "client interrupted while waiting for service to appear.");
        throw std::runtime_error("client interrupted while waiting for service to appear");
      }
      RCLCPP_INFO(this->get_logger(), "waiting for only_positive service to appear...");
    }
    outs.only_positive.init(std::bind(&node::only_positive_send_async_request, this, std::placeholders::_1));
  }

private:

  rclcpp::TimerBase::SharedPtr tick_timer;

  void tick_callback()
  {
    RCLCPP_DEBUG(this->get_logger(), "Running callback for tick");
    tick_triggered(ins, outs, recv);
    RCLCPP_DEBUG(this->get_logger(), "callback for tick completed");
  }


  // [SERVICES]
  rclcpp::Client<std_srvs::srv::SetBool>::SharedPtr only_positive_client;
  void only_positive_send_async_request(std_srvs::srv::SetBool::Request::SharedPtr request) {
    only_positive_client->async_send_request(
      request,
      std::bind(
          &node::only_positive_response_recv_callback, this, std::placeholders::_1));
  }
  void only_positive_response_recv_callback(rclcpp::Client<std_srvs::srv::SetBool>::SharedFuture future)
  {
    RCLCPP_DEBUG(get_logger(), "Running callback for response received only_positive");
    recv.only_positive = future.get();
    RCLCPP_DEBUG(get_logger(), "Running callback for response received only_positive completed");
  }

  // [ Attributes for storing all inputs, outputs and received responses ]
  arty_example_alternate_positive::inputs ins;
  arty_example_alternate_positive::outputs outs;
  arty_example_alternate_positive::responses recv;

};

}  // namespace arty_example_alternate_positive

#include <rclcpp_components/register_node_macro.hpp>
RCLCPP_COMPONENTS_REGISTER_NODE(arty_example_alternate_positive::node)